/*
short, mid long

L- last_bit
W- write
N- next last_bit
   L  W N
S: 0  0 0
   1  1 1
M: 0 01 1
   1  0 0
   
L: 0  X X
   1 01 1   


*/



module fsm_rx2(rf_in, count, reset_count, out, reset, clk, data_valid, eot, last_bit, x2rf_in, idle);
   input [4:0] count; 
   input rf_in;
   input reset;
   //input over;
   input clk;
   
   output reg [8:0] out;
   //output reg do_shift;
   output reg data_valid;
   output reg eot;
   //output reg outm;
   
   
   output reg reset_count;
   output reg last_bit;
  
        
   //reg [2:0]        state;
   //reg [2:0]        next_state;
   reg rf_old;
   reg [8:0]mask;
   
   //reg nextpar;
   reg [8:0]out_temp;
	 output reg [1:0]idle;
	 
	 reg [2:0]state;
   
   reg xrf_in;
	 output reg x2rf_in;
   
	 parameter IDLE=3'b001;
	 parameter TRIM=3'b010;
	 parameter FINISHED=3'b011;
	 parameter RXACT=3'b100;
	 parameter FULLBYTE=3'b101;
  
  always @(posedge clk or posedge reset)
  begin: decoder
if (reset == 1)
begin
	eot=1'b0;
	mask =9'b1_0000_0000;
	out=9'b0_0000_0000;
	out_temp=9'bx_xxxx_xxxx;
	last_bit<=1'b0;
	rf_old<=1'b0;
	state<=IDLE;
	data_valid<=0;
end
else 
begin
  if(reset_count==1'b1&& state!=IDLE)reset_count<=1'b0;
  if(eot==1'b1)eot=1'b0;
	if(data_valid==1'b1)data_valid<=1'b0;
    
  x2rf_in<=rf_in&!rf_old;//pos edge
	xrf_in<=rf_in&!rf_old;//pos edge
	
	if(state==IDLE)
	begin
		mask=9'b0_0000_0001;
		out_temp=0;
		last_bit<=1'b0;
		reset_count<=1;
	end
	
  if(xrf_in == 1'b1)
	begin// negative edge}
	
		if(state==IDLE)
		begin
			state<=TRIM;
		end
		/*if(state==TRIM)
		if(state==IDLE||state==TRIM)
		begin
			state<=RXACT;
		end*/
		else if(state==RXACT ||state==TRIM)
		begin
			
		
		
			if(count < 5'b00100)//short - 8
			begin
				state<=IDLE;
			end
			else if(count < 5'b01000)//short - 8
			begin
				if(last_bit==1'b0)//short,last_bit=0, write 0
				begin
					if(state==RXACT)
					begin
					out_temp=out_temp&(~mask);
					end
					last_bit<=1'b0;
				end
				else//short,last_bit=1, write 1
				begin
					if(state==RXACT)
					begin
					out_temp=out_temp|mask;
					end
					last_bit<=1'b1;
				end
			end
			else if (count < 5'b01100)//middle - 12
			begin
				if(last_bit==1'b0)//middle,last_bit=0, write 01
				begin
					if(mask==9'b1_0000_0000 /*&& idle==0*/)
					begin
						out_temp=out_temp&(~mask);//zapis 0 do parity, check parity
						out=out_temp|9'b1_0000_0000;//vystav data
						data_valid<=1;//vystav flag
						mask=8'b0000_0001;
						out_temp=9'b0_0000_0001;
					end
					//if(state==RXACT)
					begin 
						if(state==RXACT)mask=mask<<1;
						out_temp=out_temp|mask;
						if(state==TRIM)mask=mask<<1;
					end
					
					last_bit<=1'b1;
				end
				else//middle,last_bit=1, write 0
				begin
					 out_temp=out_temp&(~mask);
					last_bit<=1'b0;  
				end
			end 
			else if (count < 5'b10000)// long - 17
			//else if(count == 12 || count==13 || count==14 || count==15)
			begin
				if(last_bit==1'b0)
				begin
				//err
				end
				else//long,last_bit=1, write 01
				begin
					if(mask==9'b1_0000_0000 /*&& idle==0*/)
					begin
					out_temp=out_temp&(~mask);//zapis 0 do parity, check parity
					out=out_temp|9'b1_0000_0000;//vystav data
					data_valid<=1;//vystav flag
					mask=8'b0000_0001;
					out_temp=9'b0_0000_0001;
					end
					else
					begin 
						mask=mask<<1;
						out_temp=out_temp|mask;
					end
					last_bit<=1'b1;
				end
			end
			
			if(mask==9'b1_0000_0000 && state==RXACT) 
			begin
				mask=9'b0_0000_0001;
				out=out_temp|9'b1_0000_0000;//set output ready
				data_valid<=1;
				out_temp=9'b0_0000_0000;
			end
			else if(mask==9'b1_0000_0000 /*&& idle==1*/) 
			begin
				mask=9'b0_0000_0001;
				out_temp=9'b0_0000_0000;
			end
			
			else if(state==RXACT)
			begin
				mask=mask<<1;
			end
		end //end RXACT
	
		if(state==TRIM)state<=RXACT;

	reset_count<=1'b1;
	
	end //XRFIN
	
  //end//xrfin
	
	//async start
	/*if(idle==2)
	begin
		idle<=1;
		mask=9'b1_0000_0000;
		out_temp=9'b0_0000_0000;
		out=0;
		last_bit<=0;
	end
	else if(idle==1)
	begin
		idle<=0;
		reset_count=1'b1;
	end*/
	
	if(count>=5'b10101)
	begin//vystav castecnej zbytek, koncici ..1000.., 9bit out
	  if(state==RXACT||state==TRIM)
		begin 
			if(mask!=9'b0_0000_0001)
			begin 
				out={1'b0,out_temp[7:0]| mask[8:0]};
				data_valid<=1;
			//end
			eot=1'b1;
			end
			state<=IDLE;
		end
		
	end  
	rf_old<=rf_in;
	end //reset else
end//reset else
//end// decoder
    
endmodule

