module timer(
    input clk,
		//input txrx,
    input reset_count,
    input last_bit,
    output reg clk8,
    output reg clk64,
    output reg tx_pulse,
		input tx_loaded
    );
		
		reg [5:0] count;
		reg [3:0] countdown;
		reg offset_added;
		

		/*
	delay: 
		lastbit==0 t=n*128+20 (1172)==586
		lastbit==1 t=n*128+84 (1236)==618
*/


always @(posedge clk)
begin
	if(reset_count==1)
	begin
		count=0;
		//countdown<=11;		
		clk8<=0;
		clk64<=1;
		offset_added<=0;
		tx_pulse<=0;
	end
	else
	begin
		if(tx_pulse==1)tx_pulse<=0;
		if(offset_added==0 && count==1)
		begin
			if(last_bit==1)
			begin
				count=37;
				countdown<=9;
				clk8<=0;
				clk64<=0;
			end					
			else 
			begin
				count=5;
				countdown<=8;
				clk8<=1;
				clk64<=1;
			end
			offset_added<=1;
		end
		
		if(count==0 && countdown!=0)countdown<=countdown-1;
		if(count==0 && countdown==0 && tx_loaded==1)tx_pulse<=1;
		
		if ((count-1)%32==0) clk8<=~clk8;
		if ((count-1)%4==0) clk64<=~clk64;
		count=count+1;
	end
end

endmodule
